<!-- Layout has Header, and Two column body -->
<header>
	<!-- Navbar component -->
	<app-navbar></app-navbar>
</header>

<section class="body container">
	
	

<div class="row">

	<!-- Metadata -->
	<div class="col-12">
		<ul class="list-group media-meta-container">
			<li class="list-group-item"><b>Name:</b> {{ annotation.name || "empty" }}<li>
				<li class="list-group-item"><b>Description:</b> {{annotation.description || "empty"}}</li>
			<li class="list-group-item"><b>Author:</b> {{ annotation.author || "empty" }}</li>
			<li class="list-group-item"><b>Location:</b> {{annotation.location || "empty"}}</li>
			<li class="list-group-item"><b>Skill:</b> {{annotation.skill || "empty" }}</li>			
		</ul>
		<div class="tags-container">
			<span class="tag-item tag-spacing badge badge-primary" *ngFor="let tag of formatFragmentTags(annotation.tags)">{{ tag }}</span>
		</div>
	</div>

	<!-- Player -->
	<div class="col-lg-7 col-md-12 col-sm-12">

		<!-- switch viewer component based on mime -->
		
		<div class="viewer-img viewer" *ngIf="mediaType === 'jpg' || mediaType === 'png'">
			<img class="img-responsive" src="{{viewerUrl}}">
		</div>
		<div class="viewer-img viewer" *ngIf="mediaType === 'ogg' || mediaType === 'mp3' || mediaType === 'oga' || mediaType === 'mp2' || mediaType === 'wav' || mediaType === 'mp4' || mediaType === '3gp' || mediaType === '' ">
			<button style="borderColor: transparent" class="btn btn-sm btn-outline-info" data-toggle="modal" data-target="#playerInfoModal"><i class="fa fa-info-circle" aria-hidden="true"></i>
			</button>
			<div class="custom-player">
				<div class="video viewer" *ngIf="mediaType === 'mp4' || mediaType === '3gp'">
				    <video (click)="toggleVideo($event)" preload="metadata" #player>
				        <source src="{{viewerUrl}}" type="video/mp4" />
				        Browser not supported
				    </video>
				</div>
				
				<ngx-slider [value]="playerCurrentTime" 
							[options]="playerSliderOptions"
							(userChange)="seekedSlide($event)" ></ngx-slider>

				<!--input *ngIf="player" type="range" min="0" [max]="duration" step="0.1" [value]="playerCurrentTime" (change)="seekedSlide($event)" (mouseover)="getSliderPos()" class="form-range player-slider"  #playerSlider /-->
				<div class="media-toolbar">
					<div class="current-time-indicator">
						<span *ngIf="player">{{secondsToReadable(playerCurrentTime)}}</span> /
						<span *ngIf="player"> {{secondsToReadable(duration)}}</span>
					</div>

					<div class="player-controls">
						<button class="btn btn-sm btn-outline-primary" (click)="fastRewind()" data-toggle="tooltip" data-placement="top" title="Fast Rewind -5s" ><i class="fa fa-fast-backward" aria-hidden="true"></i>
						</button>
						<button class="btn btn-sm btn-outline-primary" (click)="rewind()" data-toggle="tooltip" data-placement="top" title="Rewind -2.5s"><i class="fa fa-backward" aria-hidden="true"></i>
						</button>
						<button class="btn btn-sm btn-outline-primary" (click)="playMedia()" data-toggle="tooltip" data-placement="top" title="Play / Pause">
							<span *ngIf="isPaused"><i class="fa fa-play" aria-hidden="true"></i>
							</span>
							<span *ngIf="!isPaused"><i class="fa fa-pause" aria-hidden="true"></i>
							</span>
						</button>
						<button class="btn btn-sm btn-outline-primary" (click)="forward()" data-toggle="tooltip" data-placement="top" title="Forward +2.5s"><i class="fa fa-forward" aria-hidden="true"></i>
						</button>
						<button class="btn btn-sm btn-outline-primary" (click)="fastForward()" data-toggle="tooltip" data-placement="top" title="Fast Forward +5s"><i class="fa fa-fast-forward" aria-hidden="true"></i>
						</button>

					</div>
					<div class="volume-control">
						<i class="fa fa-volume-down" aria-hidden="true"></i>

						<ngx-slider [value]="volume" 
									[options]="volumeSliderOptions"
									(userChange)="changeVol($event)"
									(valueChange)="changeVol($event)" >
						</ngx-slider>
						<i class="fa fa-volume-up" aria-hidden="true"></i>

					</div>

				</div>
								
			</div>
			
			
			<audio (click)="toggleVideo($event)" preload="metadata" #player>
			    <source src="{{viewerUrl}}" type="audio/mp3" />
			    Browser not supported
			</audio>


		</div>
		
	</div>

	<!-- Annotation Timeline -->
	<div class="col-lg-5 col-md-12 col-sm-12" [ngSwitch]="mediaType">
			<span *ngSwitchCase="'jpg'">
				Media type not supported
			</span>
			<span *ngSwitchCase="'png'">
				Media type not supported
			</span>
			<div class="anno-reader-wrap" *ngSwitchDefault>
				<h2 class="timeline-heading">Timeline</h2>
				<button type="button" class="btn btn-sm btn-outline-info timeline-view-opts" (click)="toggleListView($event)">
					<span *ngIf="isListView">
						<i class="fa fa-sliders" aria-hidden="true"></i>

						Timeline View
					</span>
					<span *ngIf="!isListView">
						<i class="fa fa-list" aria-hidden="true"></i>
 						List View
					</span>
				</button>
				<div class="listview-wrap" *ngIf="isListView">
					<ul class="list-group" #listViewContainer>
						<li class="list-group-item fragment" *ngFor="let fragment of fragments; index as i"
									(click)="playFragment(fragment.target.id, i)">

							<div class="anno-list">
								<div class="badge badge-pill badge-info">
									{{ secondsToReadable(getStartFrag(fragment.selector.value)) }} / {{ secondsToReadable(getEndFrag(fragment.selector.value))}}
								</div>

								<img class="img-responsive frag-image" *ngIf="isImage(fileUrl+fragment.body.imgTags) && fragment.body.imgTags" [attr.src]="fileUrl+fragment.body.imgTags" />			
								<a *ngIf="isImage(fileUrl+fragment.body.imgTags) && fragment.body.imgTags" [attr.href]="fileUrl+fragment.body.imgTags" target="_blank">See full image </a>

								<div>
									<!--label class="label">Comment</label-->
									{{ fragment.body.text }} 
								</div>
								
								<div class="tags-container">
									<!--label class="label">Tags</label-->
									<span class="tag-item tag-spacing badge badge-primary" *ngFor="let tag of formatFragmentTags(fragment.body.tags)">{{ tag }}</span>
								</div>					
							</div>
							

						</li>
					</ul>
				</div>
				<div class="timeline-wrap" *ngIf="!isListView">
					<div class="timeline">
						<div class="time-bar">
							<span>0:00:00</span><div *ngIf="duration">{{ secondsToReadable(duration) }}</div>
						</div>

						<ul class="anno-timeline" #timeline>
							<li tabindex="0" class="bubble" 
								*ngFor="let fragment of fragments; index as i" 
								[style.left]="getLeftOffset(fragment.selector.value)" 
								[style.width]="getBubbleWidth(fragment.selector.value)" 
								[attr.data-time]="fragment.selector.value.split('=')[1]" 
								(mouseenter)="bubbleOnHover($event)"
								[attr.data-id]="i"
								>

							</li>
						</ul>
					</div>
					<div class="added-annos">
						
						<ul #fragmentsContainer>
							<li *ngFor="let fragment of fragments; index as i" class="fragment" (click)="playFragment(fragment.target.id, i)">
								<div class="anno-card"> 
									<div class="badge badge-pill badge-info">
										 {{ secondsToReadable(getStartFrag(fragment.selector.value)) }} / {{ secondsToReadable(getEndFrag(fragment.selector.value))}}
									</div>
									
									<img class="img-responsive frag-image"
										[attr.src]="fileUrl+fragment.body.imgTags"
										*ngIf="isImage(fileUrl+fragment.body.imgTags) && fragment.body.imgTags" />
									<div class="tags-container">
										<span class="tag-item tag-spacing badge badge-primary"
											*ngFor="let tag of formatFragmentTags(fragment.body.tags)">{{ tag }}</span>
									</div>
									<div>{{ fragment.body.text }} </div>
									<a *ngIf="isImage(fileUrl+fragment.body.imgTags) && fragment.body.imgTags" [attr.href]="fileUrl+fragment.body.imgTags"
										target="_blank">See full image </a>
								</div>

							</li>
						</ul>
					</div>
				</div>
			</div>


	</div>

	<!-- Add Annotation -->
	<div class="col-lg-6 col-md-12 col-sm-12" [ngSwitch]="mediaType">
		<span *ngSwitchCase="'jpg'">
			
		</span>
		<span *ngSwitchCase="'png'">
			
		</span>
		<div *ngSwitchDefault>
			<!--h2>Add Annotation</h2-->
			<!--p>Instructions: Listen to the audio and note down the start and end time of your fragment. Then pause the audio and seek to the time you want to start the fragment with, and you will see the start time field with relevant time in secs.</p-->
			<div class="row">
				<div class="sm-form col-sm-6 form-group">
					<label for="frag-start">Start Time in secs</label>
					<div class="frag-column">
						<input type="number" step="0.1" id="frag-start" class="md-input form-control" [value]="startTime" [(ngModel)]="startTime" aria-describedby="starttimeHelp" placeholder="0.0" disabled>
						<button type="button" class="btn btn-sm btn-outline-info fragment-clip-control" (click)="setStartTime()" >
							<i class="fa fa-scissors" aria-hidden="true"></i> Start 
						</button>
						<button type="button" class="btn btn-sm btn-outline-info fragment-clip-control" (click)="playIntro()" >
							<i class="fa fa-play"></i> Play 
						</button>
					</div>
				  
				  
				  <small id="starttimeHelp" class="form-text text-muted">Pause audio at desired position and click on <code><i class="fa fa-scissors" aria-hidden="true"></i> Start</code> button to mark the start Time. To preview the beginning click on <code><i class="fa fa-play"></i> Play </code> button. Start Time value is always lower than End Time.</small>
				</div>
				<div class="sm-form col-sm-6 form-group">
					<label for="frag-End">End Time in secs</label>
					<div class="frag-column">
						<input type="number" step="0.1" max="{{duration}}" id="frag-End" class="md-input form-control" [(ngModel)]="endTime" aria-describedby="endtimeHelp" [value]="endTime" placeholder="0.0" disabled>
						<button type="button" class="btn btn-sm btn-outline-info fragment-clip-control" (click)="setEndTime()">
							<i class="fa fa-scissors" aria-hidden="true"></i> End 
						</button>
						<button type="button" class="btn btn-sm btn-outline-info fragment-clip-control" (click)="playOutro()">
							<i class="fa fa-play"></i> Play 
						</button>
					</div>
					
					<small id="endtimeHelp" class="form-text text-muted">Pause audio at desired position and click on <code><i class="fa fa-scissors" aria-hidden="true"></i> End </code> button to mark the End Time. To preview the Ending click on <code><i class="fa fa-play"></i> Play </code> button. End Time value is always higher than Start Time.</small>
				</div>
				<div class="sm-form form-group offset-sm-3 col-sm-6">
					<button type="button" class="btn btn-sm btn-outline-info"  (click)="previewFrag()" *ngIf="endTime"> <i class="fa fa-repeat" aria-hidden="true"></i> Preview selected fragment
					</button>
				</div>
			</div>	
				<div class="sm-form form-group">
				  <label for="user-tags">Add Tags</label>
				  <input type="text" id="user-tags" class="md-input form-control" [(ngModel)]="userTags" placeholder="tag1, tag2" aria-describedby="tagsHelp">
				  <small id="tagsHelp" class="form-text text-muted">comma(,) or space seperated tags. ex1: tag1, tag2 or #tag1 #tag2</small>
				  
				</div>

				<div class="sm-form form-group" [formGroup]="uploadForm">
				  <label for="img-tags">Add Image</label>
				  <!--input type="text" id="img-tags" class="md-input form-control" [(ngModel)]="imageTag" aria-describedby="imgtagHelp" (change)="imageFileUpload($event)"-->
				  <file-upload formControlName="file" accept="image/*" [multiple]="multipleFiles" (change)="preview()" upload></file-upload>

				  
				  <!--small id="imgtagHelp" class="form-text text-muted">Choose an image from your device.</small-->
				</div>
				<div class="image-preview mb-3" *ngIf="previewUrl">
					<h3>Image Preview</h3>
					<img [src]="previewUrl" height="auto" width="150" />                 
				</div>

				<!-- div class="sm-form">
				  <input type="text" id="fragment-time" class="md-input form-control" [(ngModel)]="userFragment">
				  <label for="fragment-time">Add Time</label>
				</div-->
				<!--Basic textarea-->
				<div class="sm-form form-group">
				  <label for="user-annotation">Add Comment</label>
				  <textarea type="text" placeholder="Say something..." id="user-annotation" class="md-textarea form-control" [(ngModel)]="textArea" aria-describedby="commentHelp" mdbInput></textarea>
				  <small id="commentHelp" class="form-text text-muted">Comment is a long form text, explaining about the fragment or tags.</small>
				</div>

				<div class="sm-form">
					<button type="button" class="btn btn-primary" (click)="submit()">Save</button>
				  </div>
		</div>
	</div>





</div>

<!-- Modal -->
<div class="modal fade" id="playerInfoModal" tabindex="-1" role="dialog" aria-labelledby="playerInfoModal" aria-hidden="true">
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h3 class="modal-title" id="playerInfoModalLabel">Keyboard Shortcuts</h3>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
      <ul class="list-group">
      	<li class="list-group-item">Play / Pause = Esc</li>
      	<li class="list-group-item">Forward = Right Arrow &#8594;</li>
      	<li class="list-group-item">Rewind = Left Arrow &#8592;</li>
      	<li class="list-group-item">Volume increase = + </li>
      	<li class="list-group-item">Volume decrease = - </li>
      </ul>
      </div>
    </div>
  </div>
</div>

</section>

<!-- Modal -->
<div class="modal fade" id="upload-modal" tabindex="-1" role="dialog" aria-labelledby="upload-modal" aria-hidden="true">
	<div class="modal-dialog" role="document">
	  <div class="modal-content">
		<div class="modal-header">
		  <h3 class="modal-title" id="upload-modal-label">Upload or Record</h3>
		  <button type="button" class="close" data-dismiss="modal" aria-label="Close" #closeUpload>
			<span aria-hidden="true">&times;</span>
		  </button>
		</div>
		<div class="modal-body">
		 <app-file-upload>
		  </app-file-upload>
		</div>
	   
	  </div>
	</div>
  </div>